Agora C++ API Reference for All Platforms

Public Member Functions | List of all members
agora::rtc::IRtcEngineEventHandlerInternal Class Reference

Inherits agora::rtc::IRtcEngineEventHandlerEx.

## Public Member Functions
virtual const char * | eventHandlerType () const
virtual bool | onEvent (RTC_EVENT evt, const std::string *payload)
Public Member Functions inherited from agora::rtc::IRtcEngineEventHandlerEx
virtual void | onJoinChannelSuccess (const RtcConnection &connection, int elapsed)
virtual void | onRejoinChannelSuccess (const RtcConnection &connection, int elapsed)
virtual void | onAudioQuality (const RtcConnection &connection, uid_t remoteUid, int quality, unsigned short delay, unsigned short lost) __deprecated
virtual void | onAudioVolumeIndication (const RtcConnection &connection, const AudioVolumeInfo *speakers, unsigned int speakerNumber, int totalVolume)
virtual void | onLeaveChannel (const RtcConnection &connection, const RtcStats &stats)
virtual void | onRtcStats (const RtcConnection &connection, const RtcStats &stats)
virtual void | onNetworkQuality (const RtcConnection &connection, uid_t remoteUid, int txQuality, int rxQuality)
virtual void | onIntraRequestReceived (const RtcConnection &connection)
virtual void | onFirstLocalVideoFramePublished (const RtcConnection &connection, int elapsed)
virtual void | onFirstRemoteVideoDecoded (const RtcConnection &connection, uid_t remoteUid, int width, int height, int elapsed)
virtual void | onVideoSizeChanged (const RtcConnection &connection, VIDEO_SOURCE_TYPE sourceType, uid_t uid, int width, int height, int rotation)
virtual void | onRemoteVideoStateChanged (const RtcConnection &connection, uid_t remoteUid, REMOTE_VIDEO_STATE state, REMOTE_VIDEO_STATE_REASON reason, int elapsed)
virtual void | onFirstRemoteVideoFrame (const RtcConnection &connection, uid_t remoteUid, int width, int height, int elapsed)
virtual void | onUserJoined (const RtcConnection &connection, uid_t remoteUid, int elapsed)
virtual void | onUserOffline (const RtcConnection &connection, uid_t remoteUid, USER_OFFLINE_REASON_TYPE reason)
virtual void | onUserMuteAudio (const RtcConnection &connection, uid_t remoteUid, bool muted) __deprecated
virtual void | onUserMuteVideo (const RtcConnection &connection, uid_t remoteUid, bool muted)
virtual void | onUserEnableVideo (const RtcConnection &connection, uid_t remoteUid, bool enabled)
virtual void | onUserEnableLocalVideo (const RtcConnection &connection, uid_t remoteUid, bool enabled) __deprecated
virtual void | onUserStateChanged (const RtcConnection &connection, uid_t remoteUid, uint32_t state)
virtual void | onLocalAudioStats (const RtcConnection &connection, const LocalAudioStats &stats)
virtual void | onRemoteAudioStats (const RtcConnection &connection, const RemoteAudioStats &stats)
virtual void | onLocalVideoStats (const RtcConnection &connection, const LocalVideoStats &stats)
virtual void | onRemoteVideoStats (const RtcConnection &connection, const RemoteVideoStats &stats)
virtual void | onConnectionLost (const RtcConnection &connection)
virtual void | onConnectionInterrupted (const RtcConnection &connection) __deprecated
virtual void | onConnectionBanned (const RtcConnection &connection)
virtual void | onStreamMessage (const RtcConnection &connection, uid_t remoteUid, int streamId, const char *data, size_t length, uint64_t sentTs)
virtual void | onStreamMessageError (const RtcConnection &connection, uid_t remoteUid, int streamId, int code, int missed, int cached)
virtual void | onRequestToken (const RtcConnection &connection)
virtual void | onLicenseValidationFailure (const RtcConnection &connection, LICENSE_ERROR_TYPE reason)
virtual void | onTokenPrivilegeWillExpire (const RtcConnection &connection, const char *token)
virtual void | onFirstLocalAudioFramePublished (const RtcConnection &connection, int elapsed)
virtual void | onFirstRemoteAudioFrame (const RtcConnection &connection, uid_t userId, int elapsed) __deprecated
virtual void | onFirstRemoteAudioDecoded (const RtcConnection &connection, uid_t uid, int elapsed) __deprecated
virtual void | onLocalAudioStateChanged (const RtcConnection &connection, LOCAL_AUDIO_STREAM_STATE state, LOCAL_AUDIO_STREAM_REASON reason)
virtual void | onRemoteAudioStateChanged (const RtcConnection &connection, uid_t remoteUid, REMOTE_AUDIO_STATE state, REMOTE_AUDIO_STATE_REASON reason, int elapsed)
virtual void | onActiveSpeaker (const RtcConnection &connection, uid_t uid)
virtual void | onClientRoleChanged (const RtcConnection &connection, CLIENT_ROLE_TYPE oldRole, CLIENT_ROLE_TYPE newRole, const ClientRoleOptions &newRoleOptions)
virtual void | onClientRoleChangeFailed (const RtcConnection &connection, CLIENT_ROLE_CHANGE_FAILED_REASON reason, CLIENT_ROLE_TYPE currentRole)
virtual void | onRemoteAudioTransportStats (const RtcConnection &connection, uid_t remoteUid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onRemoteVideoTransportStats (const RtcConnection &connection, uid_t remoteUid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onConnectionStateChanged (const RtcConnection &connection, CONNECTION_STATE_TYPE state, CONNECTION_CHANGED_REASON_TYPE reason)
virtual void | onWlAccMessage (const RtcConnection &connection, WLACC_MESSAGE_REASON reason, WLACC_SUGGEST_ACTION action, const char *wlAccMsg)
virtual void | onWlAccStats (const RtcConnection &connection, WlAccStats currentStats, WlAccStats averageStats)
virtual void | onNetworkTypeChanged (const RtcConnection &connection, NETWORK_TYPE type)
virtual void | onEncryptionError (const RtcConnection &connection, ENCRYPTION_ERROR_TYPE errorType)
virtual void | onUploadLogResult (const RtcConnection &connection, const char *requestId, bool success, UPLOAD_ERROR_REASON reason)
virtual void | onUserAccountUpdated (const RtcConnection &connection, uid_t remoteUid, const char *remoteUserAccount)
virtual void | onSnapshotTaken (const RtcConnection &connection, uid_t uid, const char *filePath, int width, int height, int errCode)
virtual void | onVideoRenderingTracingResult (const RtcConnection &connection, uid_t uid, MEDIA_TRACE_EVENT currentEvent, VideoRenderingTracingInfo tracingInfo)
virtual void | onSetRtmFlagResult (const RtcConnection &connection, int code)
virtual void | onTranscodedStreamLayoutInfo (const RtcConnection &connection, uid_t uid, int width, int height, int layoutCount, const VideoLayout *layoutlist)
virtual void | onAudioMetadataReceived (const RtcConnection &connection, uid_t uid, const char *metadata, size_t length)
virtual const char * | eventHandlerType () const
virtual void | onJoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onRejoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onAudioQuality (uid_t uid, int quality, unsigned short delay, unsigned short lost) __deprecated
virtual void | onAudioVolumeIndication (const AudioVolumeInfo *speakers, unsigned int speakerNumber, int totalVolume)
virtual void | onLeaveChannel (const RtcStats &stats)
virtual void | onRtcStats (const RtcStats &stats)
virtual void | onNetworkQuality (uid_t uid, int txQuality, int rxQuality)
virtual void | onIntraRequestReceived ()
virtual void | onFirstLocalVideoFramePublished (VIDEO_SOURCE_TYPE source, int elapsed)
virtual void | onFirstRemoteVideoDecoded (uid_t uid, int width, int height, int elapsed) __deprecated
virtual void | onVideoSizeChanged (VIDEO_SOURCE_TYPE sourceType, uid_t uid, int width, int height, int rotation)
virtual void | onLocalVideoStateChanged (VIDEO_SOURCE_TYPE source, LOCAL_VIDEO_STREAM_STATE state, LOCAL_VIDEO_STREAM_REASON reason)
virtual void | onRemoteVideoStateChanged (uid_t uid, REMOTE_VIDEO_STATE state, REMOTE_VIDEO_STATE_REASON reason, int elapsed)
virtual void | onFirstRemoteVideoFrame (uid_t uid, int width, int height, int elapsed)
virtual void | onUserJoined (uid_t uid, int elapsed)
virtual void | onUserOffline (uid_t uid, USER_OFFLINE_REASON_TYPE reason)
virtual void | onUserMuteAudio (uid_t uid, bool muted)
virtual void | onUserMuteVideo (uid_t uid, bool muted)
virtual void | onUserEnableVideo (uid_t uid, bool enabled)
virtual void | onUserEnableLocalVideo (uid_t uid, bool enabled) __deprecated
virtual void | onUserStateChanged (uid_t uid, REMOTE_USER_STATE state)
virtual void | onLocalAudioStats (const LocalAudioStats &stats)
virtual void | onRemoteAudioStats (const RemoteAudioStats &stats)
virtual void | onLocalVideoStats (VIDEO_SOURCE_TYPE source, const LocalVideoStats &stats)
virtual void | onRemoteVideoStats (const RemoteVideoStats &stats)
virtual void | onConnectionLost ()
virtual void | onConnectionInterrupted () __deprecated
virtual void | onConnectionBanned () __deprecated
virtual void | onStreamMessage (uid_t uid, int streamId, const char *data, size_t length, uint64_t sentTs)
virtual void | onStreamMessageError (uid_t uid, int streamId, int code, int missed, int cached)
virtual void | onRequestToken ()
virtual void | onTokenPrivilegeWillExpire (const char *token)
virtual void | onLicenseValidationFailure (LICENSE_ERROR_TYPE error)
virtual void | onFirstLocalAudioFramePublished (int elapsed)
virtual void | onFirstRemoteAudioFrame (uid_t uid, int elapsed) __deprecated
virtual void | onFirstRemoteAudioDecoded (uid_t uid, int elapsed) __deprecated
virtual void | onLocalAudioStateChanged (LOCAL_AUDIO_STREAM_STATE state, LOCAL_AUDIO_STREAM_REASON reason)
virtual void | onRemoteAudioStateChanged (uid_t uid, REMOTE_AUDIO_STATE state, REMOTE_AUDIO_STATE_REASON reason, int elapsed)
virtual void | onActiveSpeaker (uid_t uid)
virtual void | onClientRoleChanged (CLIENT_ROLE_TYPE oldRole, CLIENT_ROLE_TYPE newRole, const ClientRoleOptions &newRoleOptions)
virtual void | onClientRoleChangeFailed (CLIENT_ROLE_CHANGE_FAILED_REASON reason, CLIENT_ROLE_TYPE currentRole)
virtual void | onRemoteAudioTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onRemoteVideoTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onConnectionStateChanged (CONNECTION_STATE_TYPE state, CONNECTION_CHANGED_REASON_TYPE reason)
virtual void | onWlAccMessage (WLACC_MESSAGE_REASON reason, WLACC_SUGGEST_ACTION action, const char *wlAccMsg)
virtual void | onWlAccStats (const WlAccStats &currentStats, const WlAccStats &averageStats)
virtual void | onNetworkTypeChanged (NETWORK_TYPE type)
virtual void | onEncryptionError (ENCRYPTION_ERROR_TYPE errorType)
virtual void | onUploadLogResult (const char *requestId, bool success, UPLOAD_ERROR_REASON reason)
virtual void | onUserInfoUpdated (uid_t uid, const UserInfo &info)
virtual void | onUserAccountUpdated (uid_t uid, const char *userAccount)
virtual void | onAudioSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onVideoSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onAudioPublishStateChanged (const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onVideoPublishStateChanged (VIDEO_SOURCE_TYPE source, const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onSnapshotTaken (uid_t uid, const char *filePath, int width, int height, int errCode)
virtual void | onVideoRenderingTracingResult (uid_t uid, MEDIA_TRACE_EVENT currentEvent, VideoRenderingTracingInfo tracingInfo)
virtual void | onSetRtmFlagResult (int code)
virtual void | onTranscodedStreamLayoutInfo (uid_t uid, int width, int height, int layoutCount, const VideoLayout *layoutlist)
virtual void | onAudioMetadataReceived (uid_t uid, const char *metadata, size_t length)
Public Member Functions inherited from agora::rtc::IRtcEngineEventHandler
virtual | ~IRtcEngineEventHandler ()
virtual void | onJoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onRejoinChannelSuccess (const char *channel, uid_t uid, int elapsed)
virtual void | onProxyConnected (const char *channel, uid_t uid, PROXY_TYPE proxyType, const char *localProxyIp, int elapsed)
virtual void | onError (int err, const char *msg)
virtual void | onAudioQuality (uid_t uid, int quality, unsigned short delay, unsigned short lost) __deprecated
virtual void | onLastmileProbeResult (const LastmileProbeResult &result)
virtual void | onAudioVolumeIndication (const AudioVolumeInfo *speakers, unsigned int speakerNumber, int totalVolume)
virtual void | onLeaveChannel (const RtcStats &stats)
virtual void | onRtcStats (const RtcStats &stats)
virtual void | onAudioDeviceStateChanged (const char *deviceId, int deviceType, int deviceState)
virtual void | onAudioMixingPositionChanged (int64_t position)
virtual void | onAudioMixingFinished () __deprecated
virtual void | onAudioEffectFinished (int soundId)
virtual void | onVideoDeviceStateChanged (const char *deviceId, int deviceType, int deviceState)
virtual void | onNetworkQuality (uid_t uid, int txQuality, int rxQuality)
virtual void | onIntraRequestReceived ()
virtual void | onUplinkNetworkInfoUpdated (const UplinkNetworkInfo &info)
virtual void | onDownlinkNetworkInfoUpdated (const DownlinkNetworkInfo &info)
virtual void | onLastmileQuality (int quality)
virtual void | onFirstLocalVideoFrame (VIDEO_SOURCE_TYPE source, int width, int height, int elapsed)
virtual void | onFirstLocalVideoFramePublished (VIDEO_SOURCE_TYPE source, int elapsed)
virtual void | onFirstRemoteVideoDecoded (uid_t uid, int width, int height, int elapsed) __deprecated
virtual void | onVideoSizeChanged (VIDEO_SOURCE_TYPE sourceType, uid_t uid, int width, int height, int rotation)
virtual void | onLocalVideoStateChanged (VIDEO_SOURCE_TYPE source, LOCAL_VIDEO_STREAM_STATE state, LOCAL_VIDEO_STREAM_REASON reason)
virtual void | onRemoteVideoStateChanged (uid_t uid, REMOTE_VIDEO_STATE state, REMOTE_VIDEO_STATE_REASON reason, int elapsed)
virtual void | onFirstRemoteVideoFrame (uid_t uid, int width, int height, int elapsed)
virtual void | onUserJoined (uid_t uid, int elapsed)
virtual void | onUserOffline (uid_t uid, USER_OFFLINE_REASON_TYPE reason)
virtual void | onUserMuteAudio (uid_t uid, bool muted)
virtual void | onUserMuteVideo (uid_t uid, bool muted)
virtual void | onUserEnableVideo (uid_t uid, bool enabled)
virtual void | onUserStateChanged (uid_t uid, REMOTE_USER_STATE state)
virtual void | onUserEnableLocalVideo (uid_t uid, bool enabled) __deprecated
virtual void | onRemoteAudioStats (const RemoteAudioStats &stats)
virtual void | onLocalAudioStats (const LocalAudioStats &stats)
virtual void | onLocalVideoStats (VIDEO_SOURCE_TYPE source, const LocalVideoStats &stats)
virtual void | onRemoteVideoStats (const RemoteVideoStats &stats)
virtual void | onCameraReady () __deprecated
virtual void | onCameraFocusAreaChanged (int x, int y, int width, int height)
virtual void | onCameraExposureAreaChanged (int x, int y, int width, int height)
virtual void | onFacePositionChanged (int imageWidth, int imageHeight, const Rectangle *vecRectangle, const int *vecDistance, int numFaces)
virtual void | onVideoStopped () __deprecated
virtual void | onAudioMixingStateChanged (AUDIO_MIXING_STATE_TYPE state, AUDIO_MIXING_REASON_TYPE reason)
virtual void | onRhythmPlayerStateChanged (RHYTHM_PLAYER_STATE_TYPE state, RHYTHM_PLAYER_REASON reason)
virtual void | onConnectionLost ()
virtual void | onConnectionInterrupted () __deprecated
virtual void | onConnectionBanned () __deprecated
virtual void | onStreamMessage (uid_t uid, int streamId, const char *data, size_t length, uint64_t sentTs)
virtual void | onStreamMessageError (uid_t uid, int streamId, int code, int missed, int cached)
virtual void | onRequestToken ()
virtual void | onTokenPrivilegeWillExpire (const char *token)
virtual void | onLicenseValidationFailure (LICENSE_ERROR_TYPE error)
virtual void | onFirstLocalAudioFramePublished (int elapsed)
virtual void | onFirstRemoteAudioDecoded (uid_t uid, int elapsed) __deprecated
virtual void | onFirstRemoteAudioFrame (uid_t uid, int elapsed) __deprecated
virtual void | onLocalAudioStateChanged (LOCAL_AUDIO_STREAM_STATE state, LOCAL_AUDIO_STREAM_REASON reason)
virtual void | onRemoteAudioStateChanged (uid_t uid, REMOTE_AUDIO_STATE state, REMOTE_AUDIO_STATE_REASON reason, int elapsed)
virtual void | onActiveSpeaker (uid_t uid)
virtual void | onContentInspectResult (media::CONTENT_INSPECT_RESULT result)
virtual void | onSnapshotTaken (uid_t uid, const char *filePath, int width, int height, int errCode)
virtual void | onClientRoleChanged (CLIENT_ROLE_TYPE oldRole, CLIENT_ROLE_TYPE newRole, const ClientRoleOptions &newRoleOptions)
virtual void | onClientRoleChangeFailed (CLIENT_ROLE_CHANGE_FAILED_REASON reason, CLIENT_ROLE_TYPE currentRole)
virtual void | onAudioDeviceVolumeChanged (MEDIA_DEVICE_TYPE deviceType, int volume, bool muted)
virtual void | onRtmpStreamingStateChanged (const char *url, RTMP_STREAM_PUBLISH_STATE state, RTMP_STREAM_PUBLISH_REASON reason)
virtual void | onRtmpStreamingEvent (const char *url, RTMP_STREAMING_EVENT eventCode)
virtual void | onTranscodingUpdated ()
virtual void | onAudioRoutingChanged (int routing)
virtual void | onChannelMediaRelayStateChanged (int state, int code)
virtual void | onLocalPublishFallbackToAudioOnly (bool isFallbackOrRecover)
virtual void | onRemoteSubscribeFallbackToAudioOnly (uid_t uid, bool isFallbackOrRecover)
virtual void | onRemoteAudioTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onRemoteVideoTransportStats (uid_t uid, unsigned short delay, unsigned short lost, unsigned short rxKBitRate) __deprecated
virtual void | onConnectionStateChanged (CONNECTION_STATE_TYPE state, CONNECTION_CHANGED_REASON_TYPE reason)
virtual void | onWlAccMessage (WLACC_MESSAGE_REASON reason, WLACC_SUGGEST_ACTION action, const char *wlAccMsg)
virtual void | onWlAccStats (const WlAccStats &currentStats, const WlAccStats &averageStats)
virtual void | onNetworkTypeChanged (NETWORK_TYPE type)
virtual void | onEncryptionError (ENCRYPTION_ERROR_TYPE errorType)
virtual void | onPermissionError (PERMISSION_TYPE permissionType)
virtual void | onLocalUserRegistered (uid_t uid, const char *userAccount)
virtual void | onUserInfoUpdated (uid_t uid, const UserInfo &info)
virtual void | onUserAccountUpdated (uid_t uid, const char *userAccount)
virtual void | onVideoRenderingTracingResult (uid_t uid, MEDIA_TRACE_EVENT currentEvent, VideoRenderingTracingInfo tracingInfo)
virtual void | onLocalVideoTranscoderError (const TranscodingVideoStream &stream, VIDEO_TRANSCODER_ERROR error)
virtual void | onUploadLogResult (const char *requestId, bool success, UPLOAD_ERROR_REASON reason)
virtual void | onAudioSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onVideoSubscribeStateChanged (const char *channel, uid_t uid, STREAM_SUBSCRIBE_STATE oldState, STREAM_SUBSCRIBE_STATE newState, int elapseSinceLastState)
virtual void | onAudioPublishStateChanged (const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onVideoPublishStateChanged (VIDEO_SOURCE_TYPE source, const char *channel, STREAM_PUBLISH_STATE oldState, STREAM_PUBLISH_STATE newState, int elapseSinceLastState)
virtual void | onTranscodedStreamLayoutInfo (uid_t uid, int width, int height, int layoutCount, const VideoLayout *layoutlist)
virtual void | onAudioMetadataReceived (uid_t uid, const char *metadata, size_t length)
virtual void | onExtensionEventWithContext (const ExtensionContext &context, const char *key, const char *value)
virtual void | onExtensionStartedWithContext (const ExtensionContext &context)
virtual void | onExtensionStoppedWithContext (const ExtensionContext &context)
virtual void | onExtensionErrorWithContext (const ExtensionContext &context, int error, const char *message)
virtual void | onSetRtmFlagResult (int code)

## Member Function Documentation

## ◆ eventHandlerType()

virtual const char* agora::rtc::IRtcEngineEventHandlerInternal::eventHandlerType | ( |  | ) | const
| inline virtual

Reimplemented from agora::rtc::IRtcEngineEventHandlerEx.

## ◆ onEvent()

virtual bool agora::rtc::IRtcEngineEventHandlerInternal::onEvent | ( | RTC_EVENT | evt,
|  | const std::string * | payload
| ) |  |
| inline virtual